{
MAZE v1.2.0 (maybe the final version?! who knows ;-)
Distribute under GPL (General Public License), version 2 or later

Mostly Slovak comments follow now, sorry about that...

TODO:
>OK - urobene
>?? - nebude
>!! - ina forma (dalsi riadok)
>@@ - porad si sam :)

OK nejako sa pobavit (a porozmyslat o) s posx, posy - nak to je trochu more logicke

OK skore (alebo mnozstvo bodov potrebnych na dokoncenie levelu)
OK    zobrazovat pocas hry

OK zoznam levelov

OK scenario's

OK highscores

OK automaticky pohyb

OK pomalsi pohyb

OK otacat hlavu pri roznych smeroch

OK pridat prisery
OK    s AI (aby isla rovno za nim)
OK    bez AI (pohyb podla nahody) - budu ukladat bodky
OK    nech zabijaju :)
OK        nech zabijaju lepsie :)
OK    super inteligentne - algoritmus vlny
      prisery s preddefinovanou cestou? hmm, I'll think about that...

OK pridat specialne papanicko

OK pridat kluce a dvere
   davat body za kluce (ale iba do total score - nex to nepomaha k prejdeniu levelu tymto sposobom...)

OK lepsiu grafiku (nacitat zo suboru alla 'parasut'?)

?? pouzivat float poziciu (pre plynuly pohyb)
??     pohyb sikmo? - definitely not!

OK nejake haluze v rohu! (bolo privelke m1, m2 -> vykreslovanie nedefinovanych priseriek :)

OK moznost chodit 'dookola'

OK moze byt aj hudba :) - aspon v menu

OK plnofarebnu congratulations obrazovku :)

OK +indikator trvania god-modu
}

program maze;

uses crt, graph;

{odkasi vsetky tie 'otravne' :) & hlavne zdrzujuce zvukove effects}
const debug=false;

{nejake definicie}
type mad= record
       x, y, s, c:integer;
    end;
    scenarioitem=record
       name, fname:string;
    end;
    highscore=record
       score:integer;
       name:string;
    end;

{nejake premenne}
var mapa: array[0..39, 0..63] of char;
    posx, posy, otocenie, keysno, keysnoo: integer;
    tscore, score, scorelast, scorelast2, minscore, scount, lifes, mode, lastmode:integer;
    scenario: array[0..63] of scenarioitem;
    hs: array[0..9] of highscore;
    max3depth: integer;
{images}
    hlava: array[1..4, 1..2] of pointer;
    prisera: array[1..3] of pointer;
    imgother: array[1..6] of pointer;
{priserky}
    prisera1, prisera2, prisera3: array[1..10] of mad;
    m1, m2, m3: integer;

{nacita map}
procedure loadmap(fname:string);
var f:text;
    c: char;
    i, j: integer;
begin
     m1:=1;
     m2:=1;
     m3:=1;
     assign(f, fname);
     reset(f);
     readln(f, minscore, max3depth);
     for j:=0 to 39 do begin
          for i:=0 to 63 do begin
               read(f, c);
               mapa[j, i]:=c;
               if c='S' then begin
                  posx:=i;
                  posy:=j;
               end else if c='1' then begin
                  prisera1[m1].x:=i;
                  prisera1[m1].y:=j;
                  prisera1[m1].s:=random(4)+1;
                  prisera1[m1].c:=random(20);
                  m1:=m1+1;
               end else if c='2' then begin
                  prisera2[m2].x:=i;
                  prisera2[m2].y:=j;
                  prisera2[m2].c:=2;
                  m2:=m2+1;
               end else if c='3' then begin
                  prisera3[m3].x:=i;
                  prisera3[m3].y:=j;
                  prisera3[m3].c:=2;
                  m3:=m3+1;
               end;
          end;
          read(f, c);
          read(f, c);
     end;
     close(f);
     m3:=m3-1;
     m2:=m2-1;
     m1:=m1-1;
end;

{nacina 'pribeh' - zoznam levelov (malo by ich byt < 64 kvoli stabilite programu ;-) }
procedure loadscenario;
var f:text;
    i:integer;
begin
     assign(f, 'mapsdef.txt');
     reset(f);
     readln(f, scount);
     for i:=0 to scount do begin
         readln(f, scenario[i].name);
         readln(f, scenario[i].fname);
     end;
     close(f);
end;

{vyrobi nejake bitmapky, ktore budeme potrebovat}
procedure initbmps;
var f:text;
    i, j, val: integer;
begin

     assign(f, 'items.raw');
     reset(f);
     for j:=0 to 59 do begin
         for i:=0 to 79 do begin
             read(f, val);
             putpixel(i, j, val);
             if (not debug) then
                sound(val);
         end;
     end;
     close(f);

     getmem(hlava[1, 1], imagesize(0, 20, 9, 29));
     getimage(0, 20, 9, 29, hlava[1, 1]^);
     getmem(hlava[1, 2], imagesize(10, 20, 19, 29));
     getimage(10, 20, 19, 29, hlava[1, 2]^);

     getmem(hlava[2, 1], imagesize(20, 20, 29, 29));
     getimage(20, 20, 29, 29, hlava[2, 1]^);
     getmem(hlava[2, 2], imagesize(30, 20, 39, 29));
     getimage(30, 20, 39, 29, hlava[2, 2]^);

     getmem(hlava[3, 1], imagesize(0, 30, 9, 39));
     getimage(0, 30, 9, 39, hlava[3, 1]^);
     getmem(hlava[3, 2], imagesize(10, 30, 19, 39));
     getimage(10, 30, 19, 39, hlava[3, 2]^);

     getmem(hlava[4, 1], imagesize(20, 30, 29, 39));
     getimage(20, 30, 29, 39, hlava[4, 1]^);
     getmem(hlava[4, 2], imagesize(30, 30, 39, 39));
     getimage(30, 30, 39, 39, hlava[4, 2]^);

     getmem(prisera[1], imagesize(0, 10, 9, 19));
     getimage(0, 10, 9, 19, prisera[1]^);

     getmem(prisera[2], imagesize(10, 10, 19, 19));
     getimage(10, 10, 19, 19, prisera[2]^);

     getmem(prisera[3], imagesize(20, 10, 29, 19));
     getimage(20, 10, 29, 19, prisera[3]^);

     for i:=1 to 6 do begin
          getmem(imgother[i], imagesize((i-1)*10, 0, (i-1)*10+9, 9));
          getimage((i-1)*10, 0, (i-1)*10+9, 9, imgother[i]^);
     end;
end;


{vykresli prvok mapy na pozicii x, y (v mape; na obrazovke je to *10)}
procedure drawitem(x, y, c:integer);
begin
   if (c<>0) then begin
      setcolor(0);
      setfillstyle(1, 0);
      bar(x*10, y*10, x*10+10, y*10+10);
   end;
   if mapa[y, x]='#' then
        putimage(x*10, y*10, imgother[1]^, 0)
   else if mapa[y, x]='X' then
        putimage(x*10, y*10, imgother[4]^, 0)
   else if mapa[y, x]='.' then
        putimage(x*10, y*10, imgother[2]^, 0)
   else if mapa[y, x]='*' then
        putimage(x*10, y*10, imgother[3]^, 0)
   else if mapa[y, x]='%' then
        putimage(x*10, y*10, imgother[5]^, 0)
   else if mapa[y, x]='$' then
        putimage(x*10, y*10, imgother[6]^, 0);
end;

{vykresi whole mapu}
procedure drawmap;
var x, y:integer;
begin
     cleardevice;
     setcolor(0);
     for y:=0 to 39 do begin
          for x:=0 to 63 do begin
               drawitem(x, y, 0);
          end;
     end;
end;

{nastavi poziciu pacmana na x, y - ak je to mozne & urobi some specialne efekty (napr. cyklicky priestor :)}
procedure setpos(x, y:integer);
var i:integer;
begin
     drawitem(posx, posy, 1);
     if mode>0 then mode:=mode-1;

     if x>63 then x:=0;
     if x<0 then x:=63;
     if y>39 then y:=0;
     if y<0 then y:=39;

     if (mapa[y, x]<>'#') and (mapa[y, x]<>'%') then begin
         posx:=x;
         posy:=y;
         if (mapa[y, x]='.') then begin
              sound(500);
              delay(1);
              nosound;
              score:=score+1;
              mapa[y, x]:=' ';
         end else if (mapa[y, x]='*') then begin
              sound(200);
              delay(2);
              sound(600);
              delay(2);
              sound(1000);
              delay(2);
              nosound;
              mode:=150;
              mapa[y, x]:=' ';
              score:=score+50;
         end else if (mapa[y, x]='$') then begin
              for i:=1 to 20 do begin
                  sound(i*1000);
                  delay(2);
              end;
              nosound;
              keysno:=keysno+1;
              mapa[y, x]:=' ';
         end;
     end else if (mapa[y, x]='%') and (keysno>0) then begin {open the door :)}
         mapa[y, x]:=' ';
         posx:=x;
         posy:=y;
         keysno:=keysno-1;
         for i:=1 to 20 do begin
             sound(i*30);
             delay(2);
         end;
         nosound;
     end;
end;

function inmap(x, y: integer):boolean;
begin
     inmap:=(x>=0) AND (x<=63) AND (y>=0) AND (y<=39);
end;

function goodplace(x, y: integer):boolean;
begin
     goodplace:=(mapa[y, x]<>'#') and (mapa[y, x]<>'%') and inmap(x, y);
end;

{demencia 1. prisery - modrej [chodi uplne nahodne]}
procedure setPrisPos1(n, nx, ny:integer);
begin
     drawitem(prisera1[n].x, prisera1[n].y, 1);
     if goodplace(nx, ny) then begin
         prisera1[n].x:=nx;
         prisera1[n].y:=ny;
         if (random(20)=0) AND (mapa[ny, nx]<>'X') then mapa[ny, nx]:='.';
     end;
     putimage(prisera1[n].x*10+1, prisera1[n].y*10+1, prisera[1]^, 0);
end;

{inteligencia 2. prisery}
procedure setPrisPos2_2(n, nx, ny:integer);
begin
     if goodplace(nx, ny) then begin
         prisera2[n].x:=nx;
         prisera2[n].y:=ny;
     end;
end;

{inteligencia 2. prisery - fialovej [vzdy ide za hracom, neobchadza steny]}
procedure setPrisPos2(n:integer);
var px, py:integer;
begin
     drawitem(prisera2[n].x, prisera2[n].y, 1);
     px:=prisera2[n].x;
     py:=prisera2[n].y;
     if px<posx then setPrisPos2_2(n, px+1, py);
     if px>posx then setPrisPos2_2(n, px-1, py);
     if py>posy then setPrisPos2_2(n, px, py-1);
     if py<posy then setPrisPos2_2(n, px, py+1);

     putimage(prisera2[n].x*10+1, prisera2[n].y*10+1, prisera[2]^, 0);
end;

{nerad to robim takto neobecne, ale treba setrit zasobnik :)}
var vlna: array[0..39, 0..63] of BYTE;

{vyrobi vlnu, rekurzivne :-( }
procedure setPrisPos3_fill(x, y, v, h: integer);
begin
     if (h<max3depth) AND (vlna[y, x]>v) AND (mapa[y, x]<>'#') and (mapa[y, x]<>'%') then begin
        vlna[y, x]:=v;

        if (y>0) then  setPrisPos3_fill(x, y-1, v+1, h+1);
        if (x>0) then  setPrisPos3_fill(x-1, y, v+1, h+1);
        if (y<40) then setPrisPos3_fill(x, y+1, v+1, h+1);
        if (x<64) then setPrisPos3_fill(x+1, y, v+1, h+1);
     end;
end;

{inteligencia 3. prisery - cervenej [hlada optimalnu cestu algoritmom vlny]}
procedure setPrisPos3(n:integer);
var x, y, x2, y2, v:integer;
begin
     drawitem(prisera3[n].x, prisera3[n].y, 1);
     {najst najmensiu okolitu hodnotu - mensiu ako aktualnu => optimalna cesta}
     x:=prisera3[n].x;
     y:=prisera3[n].y;
     x2:=x;
     y2:=y;
     v:=vlna[y, x];

     if (y>0) AND (vlna[y-1, x]<v) then begin
        x2:=x; y2:=y-1;
     end else if (x>0) AND (vlna[y, x-1]<v) then begin
         x2:=x-1; y2:=y;
     end else if (y<40) AND (vlna[y+1, x]<v) then begin
        x2:=x; y2:=y+1;
     end else if (x<64) AND (vlna[y, x+1]<v) then begin
         x2:=x+1; y2:=y;
     end;

     prisera3[n].x:=x2;
     prisera3[n].y:=y2;
     putimage(prisera3[n].x*10+1, prisera3[n].y*10+1, prisera[3]^, 0);
end;

{jeden krok pre vsetky prisery}
procedure doprisery;
var i, x, y: integer;
begin
     for i:=1 to m1 do begin
          with prisera1[i] do begin
               if s=1 then setPrisPos1(i, x-1, y);
               if s=2 then setPrisPos1(i, x+1, y);
               if s=3 then setPrisPos1(i, x, y-1);
               if s=4 then setPrisPos1(i, x, y+1);
               c:=c-1;
               if c<0 then begin c:=random(20); s:=random(4)+1; end;
          end;
     end;

     for i:=1 to m2 do begin
          with prisera2[i] do begin
               c:=c-1;
               if c<0 then begin
                  setPrisPos2(i);
                  c:=2;
               end;
          end;
     end;

     if (m3>0) then begin
        for x:=0 to 63 do
            for y:=0 to 39 do
                vlna[y, x]:=255;

        setPrisPos3_fill(posx, posy, 0, 0);
     end;
     for i:=1 to m3 do begin
          with prisera3[i] do begin
               c:=c-1;
               if c<0 then begin
                  setPrisPos3(i);
                  c:=2;
               end;
          end;
     end;
end;

{zobrazi skore, godmode a kluce}
procedure showscore;
var i, score2: integer;
    s:string;
begin
     setcolor(15);
     if score=0 then begin
        rectangle(3, 420, 105, 440);
     end;

     if (scorelast2<(tscore+score)) then begin
          str(tscore+score, s);
          s:='Total score: '+s;
          setcolor(0);
          setfillstyle(1, 0);
          bar(400, 410, 600, 430);
          setcolor(15);
          outtextxy(400, 410, s);
          scorelast2:=tscore+score;
     end;

     setcolor(15);
     moveto(3, 410);
     outtext('Game status:');
     score2:=score;
     if score2>=minscore then score2:=minscore-1;
     setcolor(2);
     for i:=round(scorelast/minscore*100) to round(score2/minscore*100) do begin
         moveto(4+i, 421);
         linerel(0, 18);
     end;
     if (scorelast>minscore) and (scorelast<(minscore+60)) then begin
        setcolor(10);
        outtextxy(100, 410, 'You can go now!!!');
     end;
     scorelast:=score;

     if mode>0 then begin
        {if lastmode=0 then begin}
        if (mode mod 5)=0 then begin
               setfillstyle(1, 0);
               bar(3, 445, 200, 460);
               str(mode div 5, s);
               outtextxy(3, 445, 'GOD mode ON (T-'+s+')');
               lastmode:=1;
         end;
     end else if lastmode<>0 then begin
         setfillstyle(1, 0);
         bar(3, 445, 200, 460);
         outtextxy(3, 445, 'GOD mode OFF');
         lastmode:=0;
     end;

     if (keysno<>keysnoo) then begin
         keysnoo:=keysno;
         setfillstyle(1, 0);
         bar(0, 460, 200, 470);
         for i:=1 to keysno do
             putimage(i*10+1, 460, imgother[6]^, 0);
     end;
end;

{zisti, ci hrac medzicasom nezomrel}
function checkdeath:integer;
var i:integer;
begin
     checkdeath:=0;
     for i:=1 to m1 do begin
          with prisera1[i] do begin
               if (posx=x) AND (posy=y) then checkdeath:=1;
          end;
     end;

     for i:=1 to m2 do begin
          with prisera2[i] do begin
               if (posx=x) AND (posy=y) then checkdeath:=2;
          end;
     end;

     for i:=1 to m3 do begin
          with prisera3[i] do begin
               if (posx=x) AND (posy=y) then checkdeath:=3;
          end;
     end;
     if mode<>0 then checkdeath:=0;
end;

{vykresli pacmana, podla fazy a otocenia}
procedure drawgebula(otocenie, curstage:integer);
begin
     if (curstage mod 10)=0 then begin
     if otocenie<>0 then
        putimage(posx*10+1, posy*10+1, hlava[otocenie, (curstage div 250) mod 2 + 1]^, 0)
     else
        putimage(posx*10+1, posy*10+1, hlava[1, (curstage div 250) mod 2 + 1]^, 0);
     end;
end;

{zacne vlastnu hru - inicializuje all & vykonava hlavny cyklus}
function startgame2(fname:string):integer;
var curstage, exitgm : integer;
    c:char;
    i:integer;
begin
     loadmap(fname);
     drawmap;
     curstage:=1;
     otocenie:=0;
     exitgm:=0;
     score:=0;
     scorelast:=0;
     scorelast2:=0;
     mode:=0;
     lastmode:=1;
     keysno:=0;
     keysnoo:=0;

     repeat
           drawgebula(otocenie, curstage);
           if checkdeath<>0 then begin
              i:=3000;
              repeat
                    sound(i);
                    delay(2);
                    i:=i-100;
              until i<200;
              nosound;
              exitgm:=-1;
           end;
           if (curstage mod 50)=0 then begin showscore; delay(5); end;
           curstage:=curstage+1;
           if (curstage>500) then curstage:=1;
           if keypressed then
           begin
                c:=readkey;
                case c of
                'q', 'Q': exitgm:=2;
                'K': begin otocenie:=1; end;
                'M': begin otocenie:=2; end;
                'H': begin otocenie:=3; end;
                'P': begin otocenie:=4; end;
                'x': if (debug) then exitgm:=1;
                end;
           end;
           if (otocenie=1) AND (curstage=300) then setpos(posx-1, posy);
           if (otocenie=2) AND (curstage=300) then setpos(posx+1, posy);
           if (otocenie=3) AND (curstage=300) then setpos(posx, posy-1);
           if (otocenie=4) AND (curstage=300) then setpos(posx, posy+1);
           if (curstage=100) then doprisery;

           if (mapa[posy, posx]='X') AND (score>=minscore) then
                exitgm:=1;
     until exitgm<>0;
     if exitgm<0 then begin startgame2:=-1; tscore:=tscore+score; end;
     if exitgm=2 then startgame2:=1;
     if exitgm=1 then begin startgame2:=0; tscore:=tscore+score; end;
end;

{zobrazi informacie medzi levelmi}
procedure startgame_shownfo(lifes, lno:integer);
var str:string;
begin
     setbkcolor(0);
     setcolor(15);
     cleardevice;
     str:='Level `'+scenario[lno].name+'`';
     outtextxy(320-textwidth(str) div 2, 50, str);
     str:='Lifes left: ';
     if lifes=0 then str:=str+'Almost dead (0)';
     if lifes=1 then str:=str+'Uno (1)';
     if lifes=2 then str:=str+'Two (2)';
     if lifes=3 then str:=str+'Full pull (3)';
     outtextxy(320-textwidth(str) div 2, 100, str);
     if (not debug) then begin
        sound(523); delay(100); nosound; delay(50);
        sound(523); delay(100); nosound; delay(100);
        sound(880); delay(100); nosound; delay(50);
        sound(880); delay(100); nosound; delay(50);
        sound(523); delay(150); nosound; delay(100);
     end;
     while not keypressed do;
end;

{ak bol hrac velmi dobry, prida jeho score to tabulky highscore (triedenie priamym vkladanim :)}
procedure addhighscore;
var d, m, ihs, i:integer;
    name:string;
label nxt;
begin
     ihs:=-1;
     for i:=9 downto 0 do begin
         if tscore>hs[i].score then begin ihs:=i; end;
     end;
nxt:
     if ihs<>-1 then begin
          restorecrtmode;
          clrscr;
          writeln('Congratulations, you achieved a high score (with ', tscore, ')!');
          writeln('Please enter your name:');
          readln(name);
          for i:=8 downto ihs do begin
              hs[i+1].score:=hs[i].score;
              hs[i+1].name:=hs[i].name;
          end;
          hs[ihs].score:=tscore;
          hs[ihs].name:=name;
          d:=9;
          m:=2;
          initgraph(d, m, '');
     end;
end;

{niekto to presiel?! nice!}
procedure congrats;
var f:text;
    i, j: integer;
    val: integer;
begin
     assign(f, 'congrats.raw');
     reset(f);
     for j:=0 to 479 do begin
         for i:=0 to 639 do begin
             read(f, val);
             putpixel(i, j, val);
             if (not debug) then
                sound(val);
         end;
     end;
     close(f);
     readkey;
end;

{zacne hru - hlavna procedura}
procedure startgame;
var i, r:integer;
label jump, gt;
begin
     lifes:=3;
     tscore:=0;
     for i:=0 to scount-1 do begin
jump:
         if lifes<0 then goto gt;
         startgame_shownfo(lifes, i);
         r:=startgame2(scenario[i].fname);
         if r<0 then begin lifes:=lifes-1; goto jump; end;
         if r>0 then goto gt;
     end;
gt:
     if (lifes>=0) and (r=0)
         then congrats;
     addhighscore;
     cleardevice;
end;

{funky funkcia na vypisanie vycentrovaneho textu}
procedure cwriteln(txt : string);
var i,len:integer;
begin
     len:=length(txt);
     gotoxy((80-len) div 2, wherey);
     for i:=1 to len do begin
          write(txt[i]);
          if (not debug) then begin
             sound(500);
             delay(1);
             nosound;
          end;
     end;

     writeln
end;

{funky funkcia na vypisanie farebneho vycentrovaneho textu}
procedure cwriteln2(txt : string);
var i,len:integer;
begin
     textcolor(random(15)+1);
     len:=length(txt);
     gotoxy((80-len) div 2, wherey);
     for i:=1 to len do begin
          write(txt[i]);
          if (not debug) then begin
             sound(500);
             delay(1);
             nosound;
          end;
     end;
     writeln;
     textcolor(15);
end;

{zobrazi menu hry}
function showmenu:integer;
var v:integer;
    c:char;
    snd:array[1..256] of record
                               n, l, p:integer;
                         end;
    tones: array[1..256] of integer;
    f: text;
    i, j: integer;
    xs, ys : integer;
    sig: string;
    val: integer;
begin
     v:=0;
     setbkcolor(0);
     assign(f, 'music.txt');
     reset(f);
     for i:=1 to 256 do begin
         read(f, snd[i].n, snd[i].l, snd[i].p);
     end;
     close(f);
     assign(f, 'musicfrq.txt');
     reset(f);
     for i:=1 to 256 do begin
         readln(f, tones[i]);
     end;
     close(f);
     cleardevice;
     {0, 85, 170, 255}
     assign(f, 'img1.pgm');
     reset(f);
     read(f, sig, xs, ys);
     for j:=1 to ys do begin
         for i:=1 to xs do begin
             read(f, val);
             if val=0
                then putpixel(i, j, black)
             else if val=85
                then putpixel(i, j, darkgray)
             else if val=170
                then putpixel(i, j, lightgray)
             else putpixel(i, j, white);
             if (not debug) then
                sound(val);
         end;
     end;
     nosound;
     i:=0;
     repeat
          if keypressed then begin
                 c:=readkey;
                 if c='1' then v:=1;
                 if c='2' then v:=2;
                 if c='3' then v:=3;
          end;
          for j:=1 to snd[i].l div 20 do begin
              sound(tones[snd[i].n]+random(20));
              delay(snd[i].l div 20);
          end;
          nosound;
          delay(snd[i].p);
          i:=i+1;
          if i>256 then i:=1;
     until v>0;
     showmenu:=v;
end;

{zobrazi tabulku high scores}
procedure showhighscores;
var i:integer;
    s:string;
    snd:array[1..256] of record
                               n, l, p:integer;
                         end;
    tones: array[1..256] of integer;
    f: text;
begin
     cleardevice;
     assign(f, 'musichs.txt');
     reset(f);
     for i:=1 to 256 do begin
         read(f, snd[i].n, snd[i].l, snd[i].p);
     end;
     close(f);
     assign(f, 'musicfrq.txt');
     reset(f);
     for i:=1 to 256 do begin
         readln(f, tones[i]);
     end;
     close(f);
     setcolor(random(15)+1);
     outtextxy(0, 0, 'High scores');
     setcolor(15);
     for i:=0 to 9 do begin
         str(i+1, s);
         s:=s+'.';
         outtextxy(10, i*40+20, s);
         outtextxy(40, i*40+20, hs[i].name);
         str(hs[i].score, s);
         outtextxy(50, i*40+35, s);
     end;
     outtextxy(200, 450, 'Press any key to continue');
     i:=1;
     repeat
          sound(tones[snd[i].n]);
          delay(snd[i].l);
          nosound;
          delay(snd[i].p);
          i:=i+1;
          if i>20 then i:=1;
     until keypressed;
end;

{spracovava menu}
procedure startui;
var stp:integer;
begin
     stp:=0;

     repeat
          case showmenu of
               1: begin startgame; end;
               2: showhighscores;
               3: stp:=1;
               end;
     until stp=1;
end;

{nacita skore zo suboru}
procedure loadscores;
var f:text;
    i:integer;
begin
     assign(f, 'mazehs.txt');
     reset(f);
     for i:=0 to 9 do begin
         readln(f, hs[i].score);
         readln(f, hs[i].name);
     end;
     close(f);
end;

{ulozi skore do suboru}
procedure savescores;
var f:text;
    i:integer;
begin
     assign(f, 'mazehs.txt');
     rewrite(f);
     for i:=0 to 9 do begin
         writeln(f, hs[i].score);
         writeln(f, hs[i].name);
     end;
     close(f);
end;

{ (-: CORE :-) }
var d, m, i, j:integer;
begin
     clrscr;
     randomize;
     cwriteln2('MAZE (i.e. PacMan)');
     cwriteln('(C) 2002-2003 by AndreK');
     cwriteln('Please support this game by playing it for 5 minutes ;-)');
     cwriteln('');
     cwriteln('About game:');
     cwriteln('-----------');
     cwriteln('You can play using arrow keys...');
     cwriteln('Don`t let yourself to be eaten by some monster');
     cwriteln('You may eat as many dots as you can :-)');
     cwriteln('If you have enough points, you should go to X on the map');
     cwriteln('Press q on the keyboard to quit game');
     cwriteln('');
     cwriteln('');
     cwriteln('Src coda (pascal :-/) is available on my site, redistribute under GPL!');
     cwriteln('');
     cwriteln2('Homesite: http://andrek.wz.cz/');
     cwriteln2('eMail: andrek@inmail.sk');
     cwriteln('');
     cwriteln('');
     cwriteln2('Greetz fly to (dated to 2002/03):');
     cwriteln2('Wild (one), XWing, Go-Go, Invader, Hrncek, all the funky people from IV.A, ');
     cwriteln2('especially the girl from septima (2003/04) - Maja T. (no. 33);-)');
     cwriteln2('oktava nation, pals from UstavRBK and at least but not last whoever I know');
     readkey;
     loadscenario;
     d:=9;
     m:=2;
     initgraph(d, m, '');

     initbmps;
     loadscores;

     startui;

     savescores;
     closegraph;
     clrscr;
     cwriteln2('This was MAZE=PacMan');
     cwriteln('');
     cwriteln('');
     cwriteln('');
     cwriteln('Wasn`t it cool? :)');
     cwriteln('Check other nice software''n''games at:');
     cwriteln2('http://andrek.wz.cz/');
     cwriteln('Examples:');
     cwriteln2('UniView, CoolSetup, RealEffect (working-on), Atom Explosions and sum other');
     cwriteln('Send your questions, suggestions etc. to:');
     cwriteln2('andrek@inmail.sk');
     readln;
end.