{
MAZE mapGen v1.0 (there probably won't be next version)
Please distribute under GPL!
}

program tvoricmap;

uses crt, graph;

var mapa: array[0..39, 0..63] of char;
    curx, cury, curb: integer;
    score:integer;
    fpath:string;

procedure loadmap;
var f:text;
    c: char;
    i, j: integer;
begin
     assign(f, fpath);
     reset(f);
     readln(f, score);
     for j:=0 to 39 do
     begin
          for i:=0 to 63 do
          begin
               read(f, c);
               mapa[j, i]:=c;
               if c='S' then
               begin
                  curx:=i;
                  cury:=j;
               end;
          end;
          read(f, c);
          read(f, c);
     end;
     close(f);
end;

procedure drawitem(x, y:integer);
begin
   setcolor(0);
   setfillstyle(1, 0);
   bar(x*10, y*10, x*10+10, y*10+10);
   if mapa[y, x]='#' then
   begin
        setcolor(0);
        setfillstyle(1, 15);
        bar(x*10+1, y*10+1, (x+1)*10-1, (y+1)*10-1);
        moveto(x*10+1, y*10+1);
        linerel(0,0);
        moveto((x+1)*10-1, y*10+1);
        linerel(0, 0);
        moveto(x*10+1, (y+1)*10-1);
        linerel(0, 0);
        moveto((x+1)*10-1, (y+1)*10-1);
        linerel(0, 0);
   end;
   if mapa[y, x]='X' then
   begin
        setcolor(13);
        moveto(x*10+1, y*10+1);
        linerel(9,9);
        moveto((x+1)*10-1, y*10+1);
        linerel(-9, 9);
   end;
   if mapa[y, x]='S' then
   begin
        setcolor(11);
        moveto(x*10+1, y*10+1);
        linerel(9,9);
        moveto((x+1)*10-1, y*10+1);
        linerel(-9, 9);
   end;
   if mapa[y, x]='.' then
   begin
        setcolor(10);
        circle(x*10+5, y*10+5, 2);
        circle(x*10+5, y*10+5, 1);
   end;
   if mapa[y, x]='*' then
   begin
        setcolor(10);
        circle(x*10+5, y*10+5, 3);
        circle(x*10+5, y*10+5, 2);
        circle(x*10+5, y*10+5, 1);
   end;
   if mapa[y, x]='1' then
   begin
        setcolor(15);
        outtextxy(x*10+2, y*10+2, '1');
   end;
   if mapa[y, x]='2' then
   begin
        setcolor(15);
        outtextxy(x*10+2, y*10+2, '2');
   end;

   if mapa[y, x]='3' then
   begin
        setcolor(15);
        outtextxy(x*10+2, y*10+2, '3');
   end;

   if mapa[y, x]='$' then
   begin
        setcolor(15);
        outtextxy(x*10+2, y*10+2, '$');
   end;

   if mapa[y, x]='%' then
   begin
        setcolor(15);
        outtextxy(x*10+2, y*10+2, '%');
   end;
end;

procedure drawmap;
var x, y:integer;
begin
     cleardevice;
     setcolor(0);
     for y:=0 to 39 do
     begin
          for x:=0 to 63 do
          begin
               drawitem(x, y);
          end;
     end;
     setcolor(5);
     outtextxy(5, 410, '1[clear]');
     setcolor(9);
     outtextxy(75, 410, '2[block]');
     setcolor(10);
     outtextxy(145, 410, '3[exit]');
     setcolor(11);
     outtextxy(205, 410, '4[start]');
     setcolor(12);
     outtextxy(275, 410, '5[point]');
     setcolor(13);
     outtextxy(345, 410, '6[meater]');
     setcolor(14);
     outtextxy(425, 410, '7[monster1]');
     setcolor(15);
     outtextxy(520, 410, '8[mon2]');
     setcolor(8);
     outtextxy(580, 410, '9[mon3]');
     setcolor(15);
     outtextxy(5, 420, 'A[key] B[door]');

     setcolor(15);
     outtextxy(5, 430, 'S[ave map] | R[eload map] | Q[uit] | Space[draw item] | arrow keys :-)');
     outtextxy(5, 460, 'O[pen map]');
end;

procedure savemap;
var f:text;
    i, j, y, x, d, m, pts, max3:integer;
begin
     restorecrtmode;
     writeln('You are going to save file with following parameters:');
     pts:=0;
     for y:=0 to 39 do
     begin
          for x:=0 to 63 do
          begin
               if mapa[y, x]='.' then pts:=pts+1;
          end;
     end;
     writeln('Starting count of points: ', pts);
     writeln('Input minimal score to complete level [', score, ']');
     readln(score);
     writeln('Maximum wave-searching depth: (for level3 bots :)');
     readln(max3);
     writeln('Where to save?');
     readln(fpath);
     assign(f, fpath);
     rewrite(f);
     writeln(f, score, ' ', max3);
     for j:=0 to 39 do
     begin
       for i:=0 to 63 do
       begin
           write(f, mapa[j, i]);
       end;
       write(f, chr(13));
       write(f, chr(10));
     end;
     close(f);
     d:=9;
     m:=2;
     initgraph(d, m, '');
     drawmap;
end;

procedure setpos(x, y:integer);
begin
     if (x>=0) AND (x<=63) AND (y>=0) AND (y<=39) then begin
        setcolor(0);
        drawitem(curx, cury);
        setcolor(curb+8);
        if curb=0 then setcolor(5);
        rectangle(x*10, y*10, x*10+10, y*10+10);
        rectangle(x*10+1, y*10+1, x*10+9, y*10+9);
        curx:=x;
        cury:=y;
     end;
end;

procedure setmapitem(x, y, b:integer);
begin
     case b of
     0: mapa[y, x]:=' ';
     1: mapa[y, x]:='#';
     2: mapa[y, x]:='X';
     3: mapa[y, x]:='S';
     4: mapa[y, x]:='.';
     5: mapa[y, x]:='*';
     6: mapa[y, x]:='1';
     7: mapa[y, x]:='2';
     8: mapa[y, x]:='3';
     9: mapa[y, x]:='$';
     10: mapa[y, x]:='%';
     end;
     setpos(x, y);
end;

procedure openmap;
var d, m:integer;

begin
     restorecrtmode;
     clrscr;
     writeln('Input map name:');
     readln(fpath);
     d:=9;
     m:=2;
     initgraph(d, m, '');
     loadmap;

     drawmap;
end;

procedure startprog;
var exitmg : integer;
    c : char;
    drawalways: integer;
begin
     exitmg:=0;
     curx:=31;
     cury:=20;
     curb:=0;
     drawalways:=0;
     repeat
           if keypressed then
           begin
                c:=readkey;
                case c of
                'q', 'Q': exitmg:=1;
                'o', 'O': openmap;
                'K': setpos(curx-1, cury);
                'M': setpos(curx+1, cury);
                'H': setpos(curx, cury-1);
                'P': setpos(curx, cury+1);
                '1': curb:=0;
                '2': curb:=1;
                '3': curb:=2;
                '4': curb:=3;
                '5': curb:=4;
                '6': curb:=5;
                '7': curb:=6;
                '8': curb:=7;
                '9': curb:=8;
                'a': curb:=9;
                'b': curb:=10;
                ' ': setmapitem(curx, cury, curb);
                'z': drawalways:=1;
                'x': drawalways:=0;
                's': savemap;
                'r': begin loadmap; drawmap; end;
                end;
                if drawalways=1 then setmapitem(curx, cury, curb);
           end;
     until exitmg=1;
end;

procedure cwriteln(txt : string);
var i,len:integer;
begin
     len:=length(txt);
     gotoxy((80-len) div 2, wherey);
     for i:=1 to len do
     begin
          write(txt[i]);
          sound(500);
          delay(5);
          nosound;
     end;
     writeln
end;

procedure cwriteln2(txt : string);
var i,len:integer;
begin
     randomize;
     textcolor(random(15)+1);
     len:=length(txt);
     gotoxy((80-len) div 2, wherey);
     for i:=1 to len do
     begin
          write(txt[i]);
          sound(500);
          delay(5);
          nosound;
     end;
     writeln;
     textcolor(15);
end;

var d, m, i, j:integer;
begin
     clrscr;
     cwriteln2('MAZE map maker');
     cwriteln('(C) 2002-2003 by AndreK');
     fpath:='map.txt';
     readln;
     loadmap;
     d:=9;
     m:=2;
     initgraph(d, m, '');
     drawmap;
     startprog;
     closegraph;
end.